--- /dev/null	Sat Nov 22 13:16:58 2014
+++ new/usr/src/man/man7m/httpfilt.7m	Sat Nov 22 13:16:58 2014
@@ -0,0 +1,65 @@
+.\"
+.\" This file and its contents are supplied under the terms of the
+.\" Common Development and Distribution License ("CDDL"), version 1.0.
+.\" You may only use this file in accordance with the terms of version
+.\" 1.0 of the CDDL.
+.\"
+.\" A full copy of the text of the CDDL should have accompanied this
+.\" source.  A copy of the CDDL is also available via the Internet at
+.\" http://www.illumos.org/license/CDDL.
+.\"
+.\"
+.\" Copyright 2014 Ryan Zezeski
+.\"
+.Dd Nov 20, 2014
+.Dt HTTPFILT 7M
+.Os
+.Sh NAME
+.Nm httpfilt
+.Nd socket filter module for deferred HTTP connections
+.Sh DESCRIPTION
+The
+.Nm httpfilt
+socket filter provides deferment of
+.Xr accept 3SOCKET
+for HTTP connections. The accept call will not return until the CRLF
+line that designates the end of the headers has been seen, or until 8K
+has been buffered. Deferment assures the application that the first
+call to
+.Xr read 2 or
+.Xr recv 3SOCKET
+will not block. It reduces unnecessary switching between user and
+kernel.
+.Sh IMPLEMENTATION NOTES
+It's important to understand that this filter only defers HTTP
+requests, it doesn't parse them. It's not meant to be an in-kernel
+HTTP server, rejecting or accepting requests. That's still the job of
+the application. It simply does its best to buffer data until the HTTP
+request is complete, sans the body.
+.Pp
+As the filter does not implement a complete HTTP request parser it can
+be fooled. It is possible to create bogus requests which keep the
+socket deferred in the kernel indefinitely. These deferred sockets are
+allowed to stay open until the socketfilter system feels pressure and
+starts closing them.
+.Pp
+If you want to avoid indefinite deferral then
+.Xr datafilt 7M
+may be used instead. It defers the connection until at least one byte
+arrives.
+.Sh EXAMPLES
+.Ss Example 1
+Enable HTTP deferment on the listening socket.
+.Bd -literal
+    char filt[] = "httpfilt";
+    setsockopt(lsock, SOL_FILTER, FIL_ATTACH, filt, strlen(filt) + 1);
+.Ed
+.Ss Example 2
+Disable HTTP deferment on the listening socket.
+.Bd -literal
+    char filt[] = "httpfilt";
+    setsockopt(lsock, SOL_FILTER, FIL_DETACH, filt, strlen(filt) + 1);
+.Ed
+.Sh SEE ALSO
+.Xr setsockopt 3SOCKET ,
+.Xr datafilt 7M
